先附上同程笔试题一道:剑指 Offer 25. 合并两个排序的链表
链接:https://leetcode-cn.com/problems/he-bing-liang-ge-pai-xu-de-lian-biao-lcof/
输入两个递增排序的链表,合并这两个链表并使新链表中的节点仍然是递增排序的。
示例1:
输入:1->2->4, 1->3->4
输出:1->1->2->3->4->4
限制:
0 <= 链表长度 <= 1000
- 思路一: 迭代,因为给出的链表都是有序的,所有只需要进行比较,然后放值就可以了,最后判断,长度不同的情况就ok了
class Solution {
public ListNode mergeTwoLists(ListNode l1, ListNode l2) {
//判断边界情况
if(l1 == null){
return l2;
}
if(l2 == null){
return l1;
}
ListNode res = new ListNode(0);
ListNode cur = res;
while(l1 != null && l2 != null){
//比较之后进行放值
if(l1.val <= l2.val){
cur.next = l1;
l1 = l1.next;
}else{
cur.next = l2;
l2 = l2.next;
}
cur = cur.next;
}
//如果长度不相等的情况
if(l1 != null){
cur.next = l1;
}
if(l2 != null){
cur.next = l2;
}
return res.next;
}
}
- 思路二:递归,整体思路和上面的相差不多,不过可以优化写法,(参考评论区大佬写法)
class Solution {
public ListNode mergeTwoLists(ListNode l1, ListNode l2) {
if(l1 == null){
return l2;
}
if(l2 == null){
return l1;
}
ListNode res = l1.val < l2.val ? l1 : l2;
res.next = mergeTwoLists(res.next, l1.val >= l2.val ? l1 : l2);
return res;
}
}
2的幂
给定一个整数,编写一个函数来判断它是否是 2 的幂次方。
示例 1:
输入: 1
输出: true
解释: 20 = 1
示例 2:
输入: 16
输出: true
解释: 24 = 16
示例 3:
输入: 218
输出: false
- 思路一:暴力循环解决
- 思路二:位运算
class Solution {
public boolean isPowerOfTwo(int n) {
if(n <= 0){
return false;
}
return (n & (n - 1)) == 0;
}
}
今日打卡题:冗余连接II,并查集
class Solution {
int[] anc;//并查集
int[] parent;// record the father of every node to find the one with 2 fathers,记录每个点的父亲,为了找到双入度点
public int[] findRedundantDirectedConnection(int[][] edges) {
anc=new int[edges.length+1];
parent=new int[edges.length+1];
int[] edge1=null;
int[] edge2=null;
int[] lastEdgeCauseCircle=null;
for (int[] pair:edges){
int u=pair[0];
int v=pair[1];
if(anc[u]==0) anc[u]=u;
if(anc[v]==0) anc[v]=v;//init the union-find set 初始化并查集
if (parent[v]!=0){// node v already has a father, so we just skip the union of this edge and check if there will be a circle ,跳过 edge2,并记下 edge1,edge2
edge1=new int[]{parent[v],v};
edge2=pair;
} else {
parent[v]=u;
int ancU=find(u);
int ancV=find(v);
if(ancU!=ancV){
anc[ancV]=ancU;
} else { //meet a circle , 碰到了环
lastEdgeCauseCircle=pair;
}
}
}
if (edge1!=null&&edge2!=null) return lastEdgeCauseCircle==null?edge2:edge1; //如果是情况2、3,则根据有没有碰到环返回 edge1 或 edge2
else return lastEdgeCauseCircle; //否则就是情况1,返回那个导致环的最后出现的边。
}
private int find(int node){
if (anc[node]==node) return node;
anc[node]=find(anc[node]);
return anc[node];
}
}